diff --git a/src/include/storage/page_compression.h b/src/include/storage/page_compression.h
new file mode 100644
index 0000000000..2d36bd8130
--- /dev/null
+++ b/src/include/storage/page_compression.h
@@ -0,0 +1,203 @@
+/*
+ * page_compression.h
+ *		internal declarations for page compression
+ *
+ * Copyright (c) 2022, PostgreSQL Global Development Group
+ *
+ * IDENTIFICATION
+ *		src/include/storage/page_compression.h
+ */
+
+#ifndef PAGE_COMPRESSION_H
+#define PAGE_COMPRESSION_H
+
+#include <sys/mman.h>
+
+#include "storage/bufpage.h"
+#include "datatype/timestamp.h"
+
+#ifdef FRONTEND
+typedef uint32 pg_atomic_uint32;
+#else
+#include "port/atomics.h"
+
+/* The page compression feature relies on native atomic operation support.
+ * On platforms that do not support native atomic operations, the members
+ * of pg_atomic_uint32 contain semaphore objects, which will affect the
+ * persistence of compressed page address files.
+ */
+#define SUPPORT_PAGE_COMPRESSION (sizeof(pg_atomic_uint32) == sizeof(uint32))
+#endif
+
+/* In order to avoid the inconsistency of address metadata when the server
+ * is crash, it is necessary to prevent the address metadata of one data block
+ * from crossing two storage device blocks. The block size of ordinary storage
+ * devices is a multiple of 512, so 512 is used as the block size of the
+ * page compression address file.
+ */
+#define COMPRESS_ADDR_BLCKSZ 512
+
+typedef uint32 pc_chunk_number_t;
+
+/* Compression algorithms for page compression */
+typedef enum PageCompression
+{
+	PAGE_COMPRESSION_NONE = 0,
+	PAGE_COMPRESSION_PGLZ,
+	PAGE_COMPRESSION_LZ4,
+	PAGE_COMPRESSION_ZSTD
+} PageCompression;
+
+/*
+ * Layout of files for page compression:
+ *
+ * 1. page compression address file(_pca)
+ * - PageCompressHeader
+ * - PageCompressAddr[0]
+ * - PageCompressAddr[1]
+ * - ...
+ *
+ * 2. page compression data file(_pcd)
+ * - PageCompressChunk[0]
+ *   - PageCompressData(in whole or in part)
+ * - PageCompressChunk[1]
+ *   - PageCompressData(in whole or in part)
+ * - ...
+ */
+
+typedef struct PageCompressHeader
+{
+	pg_atomic_uint32 nblocks;	/* number of total blocks in this segment */
+	pg_atomic_uint32 allocated_chunks;	/* number of total allocated chunks in
+										 * data area */
+	uint16		chunk_size;		/* size of chunk, must be 1/2, 1/4, 1/8 or
+								 * 1/16 of BLCKSZ */
+	uint8		algorithm;		/* compress algorithm, 1=pglz, 2=lz4 3=zstd */
+	pg_atomic_uint32 last_synced_nblocks;	/* last synced nblocks */
+	pg_atomic_uint32 last_synced_allocated_chunks;	/* last synced
+													 * allocated_chunks */
+	TimestampTz last_recovery_start_time;	/* postmaster start time of last
+											 * recovery */
+} PageCompressHeader;
+
+typedef struct PageCompressAddr
+{
+	volatile uint8 nchunks;		/* number of chunks for this block */
+	volatile uint8 allocated_chunks;	/* number of allocated chunks for this
+										 * block */
+
+	/*
+	 * variable-length fields, 1 based chunk number array for this block, size
+	 * of the array is "BLCKSZ/chunk_size + 1"
+	 */
+	pc_chunk_number_t chunknos[FLEXIBLE_ARRAY_MEMBER];
+} PageCompressAddr;
+
+typedef struct PageCompressChunk
+{
+	uint32		blockno;		/* block number of the block stored in this
+								 * chunk */
+	uint8		chunkseq;		/* index of this chunk, from 1 to
+								 * allocated_chunks */
+	uint8		withdata:1,		/* if has data */
+				unused:7;
+	uint16		checksum;		/* checksum of this chunk */
+	char		data[FLEXIBLE_ARRAY_MEMBER];	/* 1/nchunks of
+												 * PageCompressData , and at
+												 * least 4-byte aligned */
+} PageCompressChunk;
+
+typedef struct PageCompressData
+{
+	char		page_header[SizeOfPageHeaderData];	/* page header */
+	uint16		size;			/* size of data */
+	uint16		unused;
+	char		data[FLEXIBLE_ARRAY_MEMBER];	/* data of compressed page,
+												 * except for the page header */
+} PageCompressData;
+
+/*
+ * Use this, not "char buf[BLCKSZ + BLCKSZ/2]", to declare a field or local
+ * variable holding a buffer for all chunks for one compressed page, if that buffer
+ * need to be aligned, such as when calculating checksum. (In some places, we use
+ * this to declare buffers even though we only pass them to read() and
+ * write(), because copying to/from aligned buffers is usually faster than
+ * using unaligned buffers.)  We include both "double" and "int64" in the
+ * union to ensure that the compiler knows the value must be MAXALIGN'ed
+ * (cf. configure's computation of MAXIMUM_ALIGNOF).
+ */
+typedef union PGAlignedCompressChunks
+{
+	char		data[BLCKSZ + BLCKSZ / 2];
+	double		force_align_d;
+	int64		force_align_i64;
+}			PGAlignedCompressChunks;
+
+#define IsValidPageCompressChunkSize(chunk_size) \
+	((chunk_size) == BLCKSZ / 2 || \
+	 (chunk_size) == BLCKSZ / 4 || \
+	 (chunk_size) == BLCKSZ / 8 || \
+	 (chunk_size) == BLCKSZ / 16)
+
+#define SizeOfPageCompressHeaderData sizeof(PageCompressHeader)
+#define SizeOfPageCompressAddrHeaderData offsetof(PageCompressAddr, chunknos)
+#define SizeOfPageCompressChunkHeaderData offsetof(PageCompressChunk, data)
+#define SizeOfPageCompressDataHeaderData offsetof(PageCompressData, data)
+
+#define MaxChunksPreCompressedPage(chunk_size) \
+	(BLCKSZ / (chunk_size) + 1)
+
+#define SizeOfPageCompressAddr(chunk_size) \
+	(SizeOfPageCompressAddrHeaderData + sizeof(pc_chunk_number_t) * MaxChunksPreCompressedPage(chunk_size))
+
+#define NumberOfPageCompressAddrPerBlock(chunk_size) \
+	(COMPRESS_ADDR_BLCKSZ / SizeOfPageCompressAddr(chunk_size))
+
+#define OffsetOfPageCompressAddr(chunk_size, blockno) \
+	(COMPRESS_ADDR_BLCKSZ * (1 + (blockno) / NumberOfPageCompressAddrPerBlock(chunk_size)) \
+	+ SizeOfPageCompressAddr(chunk_size) * ((blockno) % NumberOfPageCompressAddrPerBlock(chunk_size)))
+
+#define GetPageCompressAddr(pcbuffer, chunk_size, blockno) \
+	(PageCompressAddr *)((char *)(pcbuffer) + OffsetOfPageCompressAddr((chunk_size),(blockno) % RELSEG_SIZE))
+
+#define SizeofPageCompressAddrFile(chunk_size) \
+	OffsetOfPageCompressAddr((chunk_size), RELSEG_SIZE)
+
+#define OffsetOfPageCompressChunk(chunk_size, chunkno) \
+	((chunk_size) * ((chunkno) - 1))
+
+#define StoreCapacityPerPageCompressChunk(chunk_size) \
+	(chunk_size - SizeOfPageCompressChunkHeaderData)
+
+#define NeedPageCompressChunksToStoreData(chunk_size, data_size) \
+	((data_size + StoreCapacityPerPageCompressChunk(chunk_size) - 1) / StoreCapacityPerPageCompressChunk(chunk_size))
+
+
+#define MAX_PAGE_COMPRESS_ADDRESS_FILE_SIZE SizeofPageCompressAddrFile(BLCKSZ / 16)
+
+#define MAX_PAGE_COMPRESS_CHUNK_NUMBER(chunk_size) \
+	(RELSEG_SIZE * MaxChunksPreCompressedPage(chunk_size))
+
+/*
+ * After allocated 32MB data space, sync the page compression address file.
+ */
+#define COMPRESS_ADDRESS_SYNC_THRESHOLD(chunk_size) (32 * 1024 * 1024 / (chunk_size))
+
+/* Compress function */
+extern int	compress_page_buffer_bound(uint8 algorithm);
+extern int	compress_page(const char *src, char *dst, int dst_size, uint8 algorithm, int8 level);
+extern int	decompress_page(const char *src, char *dst, uint8 algorithm);
+
+/* Memory mapping function */
+extern PageCompressHeader *pc_mmap(int fd, int chunk_size, bool readonly);
+extern int	pc_munmap(PageCompressHeader *map);
+extern int	pc_msync(PageCompressHeader *map);
+
+
+#ifndef FRONTEND
+int			errcode_for_dynamic_shared_memory(void);
+void		check_and_repair_compress_address(PageCompressHeader *pcmap, uint16 chunk_size, uint8 algorithm,
+											  const char *path, int fd_pcd, const char *path_pcd);
+#endif
+
+#endif							/* PAGE_COMPRESSION_H */
diff --git a/src/include/storage/page_compression_impl.h b/src/include/storage/page_compression_impl.h
new file mode 100644
index 0000000000..2b647d5bbd
--- /dev/null
+++ b/src/include/storage/page_compression_impl.h
@@ -0,0 +1,294 @@
+#include <stdio.h>
+#include <unistd.h>
+#include <fcntl.h>
+#include <linux/falloc.h>
+#include <sys/stat.h>
+#include <assert.h>
+#include <sys/mman.h>
+
+#include "common/pg_lzcompress.h"
+
+#ifdef USE_LZ4
+#include <lz4.h>
+#endif
+
+#ifdef USE_ZSTD
+#include <zstd.h>
+
+#define DEFAULT_ZSTD_COMPRESSION_LEVEL 1
+#define MIN_ZSTD_COMPRESSION_LEVEL ZSTD_minCLevel()
+#define MAX_ZSTD_COMPRESSION_LEVEL ZSTD_maxCLevel()
+#endif
+
+
+/**
+ * compress_page_buffer_bound()
+ *  Get the destination buffer boundary to compress one page.
+ *
+ *  Return needed destination buffer size for compress one page or
+ *     -1 for unrecognized compression algorithm
+ *
+ */
+int
+compress_page_buffer_bound(uint8 algorithm)
+{
+	int			result = 0;
+
+	switch (algorithm)
+	{
+		case PAGE_COMPRESSION_PGLZ:
+			result = PGLZ_MAX_OUTPUT(BLCKSZ - SizeOfPageHeaderData);
+			break;
+#ifdef USE_LZ4
+		case PAGE_COMPRESSION_LZ4:
+			result = LZ4_compressBound(BLCKSZ - SizeOfPageHeaderData);
+			break;
+#endif
+#ifdef USE_ZSTD
+		case PAGE_COMPRESSION_ZSTD:
+			result = ZSTD_compressBound(BLCKSZ - SizeOfPageHeaderData);
+			break;
+#endif
+		default:
+			return -1;
+			break;
+	}
+	if (result < 0)
+		return -1;
+
+	return result + SizeOfPageCompressDataHeaderData;
+}
+
+/**
+ * compress_page() -- Compress one page.
+ *
+ *	Only the parts other than the page header will be compressed.
+ *	This function returns the size of compressed data or
+ *	    -1 for compression fail
+ *	    -2 for unrecognized compression algorithm
+* 	note:The size of dst must be greater than or equal to "BLCKSZ + chunck_size".
+ */
+int
+compress_page(const char *src, char *dst, int dst_size, uint8 algorithm, int8 level)
+{
+	int			compressed_size;
+	PageCompressData *pcdata;
+
+	pcdata = (PageCompressData *) dst;
+
+	switch (algorithm)
+	{
+		case PAGE_COMPRESSION_PGLZ:
+			compressed_size = pglz_compress(src + SizeOfPageHeaderData,
+											BLCKSZ - SizeOfPageHeaderData,
+											pcdata->data,
+											PGLZ_strategy_always);
+			break;
+
+#ifdef USE_LZ4
+		case PAGE_COMPRESSION_LZ4:
+			{
+				compressed_size = LZ4_compress_default(src + SizeOfPageHeaderData,
+													   pcdata->data,
+													   BLCKSZ - SizeOfPageHeaderData,
+													   dst_size);
+				if (compressed_size <= 0)
+				{
+					return -1;
+				}
+				break;
+			}
+#endif
+
+#ifdef USE_ZSTD
+		case PAGE_COMPRESSION_ZSTD:
+			{
+				int			real_level = level;
+
+				if (level == 0)
+					real_level = DEFAULT_ZSTD_COMPRESSION_LEVEL;
+				else if (level < MIN_ZSTD_COMPRESSION_LEVEL)
+					real_level = MIN_ZSTD_COMPRESSION_LEVEL;
+				else if (level > MAX_ZSTD_COMPRESSION_LEVEL)
+					real_level = MAX_ZSTD_COMPRESSION_LEVEL;
+
+				compressed_size = ZSTD_compress(pcdata->data,
+												dst_size,
+												src + SizeOfPageHeaderData,
+												BLCKSZ - SizeOfPageHeaderData,
+												real_level);
+
+				if (ZSTD_isError(compressed_size))
+				{
+					return -1;
+				}
+				break;
+			}
+#endif
+		default:
+			return -2;
+			break;
+	}
+
+	if (compressed_size < 0)
+		return -1;
+
+	memcpy(pcdata->page_header, src, SizeOfPageHeaderData);
+	pcdata->size = compressed_size;
+
+	return SizeOfPageCompressDataHeaderData + compressed_size;
+}
+
+/**
+ * decompress_page() -- Decompress one compressed page.
+ *  Returns size of decompressed page which should be BLCKSZ or
+ *         -1 for decompress error
+ *         -2 for unrecognized compression algorithm
+ *
+ * 	note:The size of dst must be greater than or equal to BLCKSZ.
+ */
+int
+decompress_page(const char *src, char *dst, uint8 algorithm)
+{
+	int			decompressed_size;
+	PageCompressData *pcdata;
+
+	pcdata = (PageCompressData *) src;
+
+	memcpy(dst, src, SizeOfPageHeaderData);
+
+	switch (algorithm)
+	{
+		case PAGE_COMPRESSION_PGLZ:
+			decompressed_size = pglz_decompress(pcdata->data,
+												pcdata->size,
+												dst + SizeOfPageHeaderData,
+												BLCKSZ - SizeOfPageHeaderData,
+												false);
+			if (decompressed_size < 0)
+			{
+				return -1;
+			}
+			break;
+
+#ifdef USE_LZ4
+		case PAGE_COMPRESSION_LZ4:
+			decompressed_size = LZ4_decompress_safe(pcdata->data,
+													dst + SizeOfPageHeaderData,
+													pcdata->size,
+													BLCKSZ - SizeOfPageHeaderData);
+
+			if (decompressed_size < 0)
+			{
+				return -1;
+			}
+
+			break;
+#endif
+
+#ifdef USE_ZSTD
+		case PAGE_COMPRESSION_ZSTD:
+			decompressed_size = ZSTD_decompress(dst + SizeOfPageHeaderData,
+												BLCKSZ - SizeOfPageHeaderData,
+												pcdata->data,
+												pcdata->size);
+
+			if (ZSTD_isError(decompressed_size))
+			{
+				return -1;
+			}
+
+			break;
+#endif
+
+		default:
+			return -2;
+			break;
+
+	}
+
+	return SizeOfPageHeaderData + decompressed_size;
+}
+
+
+/**
+ * pc_mmap() -- create memory map for address file of comressed relation.
+ *
+ */
+PageCompressHeader *
+pc_mmap(int fd, int chunk_size, bool readonly)
+{
+	PageCompressHeader *map;
+	int			file_size,
+				pc_memory_map_size;
+
+	pc_memory_map_size = SizeofPageCompressAddrFile(chunk_size);
+
+	file_size = lseek(fd, 0, SEEK_END);
+	if (file_size != pc_memory_map_size)
+	{
+		if (ftruncate(fd, pc_memory_map_size) != 0)
+			return (PageCompressHeader *) MAP_FAILED;
+	}
+
+#ifdef WIN32
+	{
+		HANDLE		mh;
+
+		if (readonly)
+			mh = CreateSnapshotMapping((HANDLE) _get_osfhandle(fd), NULL, PAGE_READONLY,
+									   0, (DWORD) pc_memory_map_size, NULL);
+		else
+			mh = CreateSnapshotMapping((HANDLE) _get_osfhandle(fd), NULL, PAGE_READWRITE,
+									   0, (DWORD) pc_memory_map_size, NULL);
+
+		if (mh == NULL)
+			return (PageCompressHeader *) MAP_FAILED;
+
+		map = (PageCompressHeader *) MapViewOfFile(mh, FILE_MAP_ALL_ACCESS, 0, 0, 0);
+		CloseHandle(mh);
+	}
+	if (map == NULL)
+		return (PageCompressHeader *) MAP_FAILED;
+
+#else
+	if (readonly)
+		map = (PageCompressHeader *) mmap(NULL, pc_memory_map_size, PROT_READ, MAP_SHARED, fd, 0);
+	else
+		map = (PageCompressHeader *) mmap(NULL, pc_memory_map_size, PROT_WRITE | PROT_READ, MAP_SHARED, fd, 0);
+#endif
+	return map;
+}
+
+/**
+ * pc_munmap() -- release memory map of page compression address file.
+ *
+ */
+int
+pc_munmap(PageCompressHeader *map)
+{
+#ifdef WIN32
+	return UnmapViewOfFile(map) ? 0 : -1;
+#else
+	return munmap(map, SizeofPageCompressAddrFile(map->chunk_size));
+#endif
+}
+
+/**
+ * pc_msync() -- sync memory map of page compression address file.
+ *
+ */
+int
+pc_msync(PageCompressHeader *map)
+{
+#ifndef FRONTEND
+	if (!enableFsync)
+		return 0;
+#endif
+
+#ifdef WIN32
+	return FlushViewOfFile(map, SizeofPageCompressAddrFile(map->chunk_size)) ? 0 : -1;
+#else
+	return msync(map, SizeofPageCompressAddrFile(map->chunk_size), MS_SYNC);
+#endif
+}
diff --git a/src/include/storage/relfilelocator.h b/src/include/storage/relfilelocator.h
index 10f41f3abb..ef7e2d72f4 100644
--- a/src/include/storage/relfilelocator.h
+++ b/src/include/storage/relfilelocator.h
@@ -17,6 +17,17 @@
 #include "common/relpath.h"
 #include "storage/backendid.h"
 
+/*
+* compression options for compressed relation
+*/
+typedef struct RelFileNodeCompressOpts
+{
+    uint8       algorithm;          /* compression algorithm */
+    int8        level;              /* compression level */
+    uint8       chunks_pre_block;   /* number of chunks per block for compressed relation */
+    uint8       prealloc_chunks;    /* prealloced chunks to store compressed data */
+} RelFileNodeCompressOpts;
+
 /*
  * RelFileLocator must provide all that we need to know to physically access
  * a relation, with the exception of the backend ID, which can be provided
@@ -59,6 +70,7 @@ typedef struct RelFileLocator
 	Oid			spcOid;			/* tablespace */
 	Oid			dbOid;			/* database */
 	RelFileNumber relNumber;	/* relation */
+    RelFileNodeCompressOpts compressOpt;    /* compression options */
 } RelFileLocator;
 
 /*
diff --git a/src/include/utils/rel.h b/src/include/utils/rel.h
index 7dc401cf0d..1f915633c1 100644
--- a/src/include/utils/rel.h
+++ b/src/include/utils/rel.h
@@ -23,6 +23,7 @@
 #include "partitioning/partdefs.h"
 #include "rewrite/prs2lock.h"
 #include "storage/block.h"
+#include "storage/page_compression.h"
 #include "storage/relfilelocator.h"
 #include "storage/smgr.h"
 #include "utils/relcache.h"
@@ -329,6 +330,18 @@ typedef enum StdRdOptIndexCleanup
 	STDRD_OPTION_VACUUM_INDEX_CLEANUP_ON
 } StdRdOptIndexCleanup;
 
+/* PageCompressOpts->compresstype values */
+typedef PageCompression compressTypeOption;
+
+ /* page compression related reloptions. */
+typedef struct PageCompressOpts
+{
+	compressTypeOption	compresstype; 				/* compress algorithm */
+	int					compresslevel;				/* compress level */
+	int					compress_chunk_size;		/* chunk size of compressed data */
+	int					compress_prealloc_chunks;	/* prealloced chunks to store compressed data */
+} PageCompressOpts;
+
 typedef struct StdRdOptions
 {
 	int32		vl_len_;		/* varlena header (do not touch directly!) */
@@ -339,6 +352,7 @@ typedef struct StdRdOptions
 	int			parallel_workers;	/* max number of parallel workers */
 	StdRdOptIndexCleanup vacuum_index_cleanup;	/* controls index vacuuming */
 	bool		vacuum_truncate;	/* enables vacuum to truncate a relation */
+	PageCompressOpts	compress; /* page compression related reloptions. */
 } StdRdOptions;
 
 #define HEAP_MIN_FILLFACTOR			10
diff --git a/src/include/utils/relcache.h b/src/include/utils/relcache.h
index ba35d6b3b3..a9eba9a622 100644
--- a/src/include/utils/relcache.h
+++ b/src/include/utils/relcache.h
@@ -108,7 +108,8 @@ extern Relation RelationBuildLocalRelation(const char *relname,
 										   bool shared_relation,
 										   bool mapped_relation,
 										   char relpersistence,
-										   char relkind);
+										   char relkind,
+										   Datum reloptions);
 
 /*
  * Routines to manage assignment of new relfilenumber to a relation
diff --git a/src/include/utils/wait_event.h b/src/include/utils/wait_event.h
index c3ade01120..5e99d304c0 100644
--- a/src/include/utils/wait_event.h
+++ b/src/include/utils/wait_event.h
@@ -230,7 +230,9 @@ typedef enum
 	WAIT_EVENT_WAL_READ,
 	WAIT_EVENT_WAL_SYNC,
 	WAIT_EVENT_WAL_SYNC_METHOD_ASSIGN,
-	WAIT_EVENT_WAL_WRITE
+	WAIT_EVENT_WAL_WRITE,
+	WAIT_EVENT_COMPRESS_ADDRESS_FILE_FLUSH,
+	WAIT_EVENT_COMPRESS_ADDRESS_FILE_SYNC
 } WaitEventIO;
 
 
